* check calculation of Hosmer & Lemeshow x2 statistic
use http://www.stata-press.com/data/r13/lbw,clear
logistic low age lwt i.race smoke ptl ht ui
estat gof,group(10) table
predict phat,pr
sort phat

*works in this case; more complicated in general; gives the HL sequential groups
gen g=int((_n-1)/19)+1
sort g

* number of expected events per group
by g:egen expect=sum(phat)
* total number of persons per group
by g:egen total=count(phat)
* total number of persons with dependent=1 per group
by g:egen obs1=sum(low)
*contribution to HL x2 statistic per group
* (y-np)^2 / np(1-p) <=> (obs1-exp)^2 / exp*(1-exp/total)
gen contrHL=((obs1-expect)^2)/(exp*(1-exp/total))

* sum over HL groups
by g:keep if _n==1
egen HL=sum(contrHL)
di HL[1]

